unit Rot3data;

{===========================================================
 Please note, that the program ROT3DATA additionally uses the
 unit NumLab, which is not supplied with the ROT3D package.
 If you don't have it, you can download the shareware version
 from one of the following WWW sites:
     http://qspr03.tuwien.ac.at/lo/
     http://www.lohninger.com/
 ===========================================================}

{
a color choice for the bounding box:

      ColorChart:        $00FFF8E0
      ColorCubeFaceHigh: $00FCFCFF
      ColorCubeFaceLow:  $00EEEEFF
      ColorCubeFrame:    clMaroon
      ColorCubeHidLin:   $00DADADA
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Rot3D, ExtCtrls, NumLab, Buttons, Menus;
  
type
  TForm1 = class(TForm)
    Rot3D1: TRot3D;
    NLabAlpha: TNumLab;
    SBAngX: TScrollBar;
    SBAngY: TScrollBar;
    NLabBeta: TNumLab;
    ScrollBar4: TScrollBar;
    NumLab4: TNumLab;
    BButExit: TBitBtn;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    CheckBox1: TCheckBox;
    SBBBSize: TScrollBar;
    SBAutoRot: TSpeedButton;
    SBAxSize: TScrollBar;
    PopupMenu1: TPopupMenu;
    Rotate1: TMenuItem;
    Zoom1: TMenuItem;
    Pan1: TMenuItem;
    SBAngZ: TScrollBar;
    NLabGamma: TNumLab;
    Label1: TLabel;
    Label2: TLabel;
    copy1: TMenuItem;
    ToClipboard1: TMenuItem;
    ToBMPFile1: TMenuItem;
    SaveDialog1: TSaveDialog;
    procedure SBAngXChange(Sender: TObject);
    procedure SBAngYChange(Sender: TObject);
    procedure ScrollBar4Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Rot3D1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BButExitClick(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SBBBSizeChange(Sender: TObject);
    procedure SBAutoRotClick(Sender: TObject);
    procedure SBAxSizeChange(Sender: TObject);
    procedure Rotate1Click(Sender: TObject);
    procedure Zoom1Click(Sender: TObject);
    procedure Pan1Click(Sender: TObject);
    procedure SBAngZChange(Sender: TObject);
    procedure ToClipboard1Click(Sender: TObject);
    procedure ToBMPFile1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
  vax, vay : double;


(***************************************************************)
procedure TForm1.SBAngXChange(Sender: TObject);
(***************************************************************)

begin
Rot3D1.ViewAngleX := SBAngX.Position;
NLabAlpha.Value := SBAngX.Position;
end;

(***************************************************************)
procedure TForm1.SBAngYChange(Sender: TObject);
(***************************************************************)

begin
Rot3D1.ViewAngleY := SBAngY.Position;
NLabBeta.Value := SBAngY.Position;
end;

(***************************************************************)
procedure TForm1.SBAngZChange(Sender: TObject);
(***************************************************************)

begin
Rot3D1.ViewAngleZ := SBAngZ.Position;
NLabGamma.Value := SBAngZ.Position;
end;


(***************************************************************)
procedure TForm1.ScrollBar4Change(Sender: TObject);
(***************************************************************)

begin
Rot3D1.Magnification := 1-Scrollbar4.Position/100;
NumLab4.VAlue := Rot3D1.Magnification;
end;

(***************************************************************)
procedure TForm1.FormActivate(Sender: TObject);
(***************************************************************)

var
  i : integer;
  rx, ry, rz : double;

begin
Rot3D1.ColorData := clBlue;
for i:=1 to 100 do   { banana }
  begin
  rx := 300.0*random;
  ry := rx + 50*random;
  rz := 30*random+sqr(rx+ry)/1400;
  Rot3D1.MarkAt (rx,ry,rz,10);
  end;
Rot3D1.ColorData := clGreen;
for i:=1 to 50 do
  Rot3D1.MarkAt (200+70*random,100+30*random,200+30*random,12);
Rot3D1.MakeVisible;
end;

(***************************************************************)
procedure TForm1.Rot3D1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
(***************************************************************)

begin
if ssLeft in Shift then
  begin
  vax := Rot3D1.ViewAngleX;
  vay := Rot3D1.ViewAngley;
  end;
end;

(***************************************************************)
procedure TForm1.BButExitClick(Sender: TObject);
(***************************************************************)

begin
SBAutoRot.Down := false;
close;
end;

(***************************************************************)
procedure TForm1.RadioButton1Click(Sender: TObject);
(***************************************************************)

begin
Rot3D1.BoundBoxStyle := bbNone;
end;

(***************************************************************)
procedure TForm1.RadioButton2Click(Sender: TObject);
(***************************************************************)

begin
Rot3D1.BoundBoxStyle := bbFrame;
end;

(***************************************************************)
procedure TForm1.RadioButton3Click(Sender: TObject);
(***************************************************************)

begin
Rot3D1.BoundBoxStyle := bbFaces;
end;

(***************************************************************)
procedure TForm1.CheckBox1Click(Sender: TObject);
(***************************************************************)

begin
Rot3D1.ShowAxes := CheckBox1.Checked;
end;

(***************************************************************)
procedure TForm1.SBBBSizeChange(Sender: TObject);
(***************************************************************)

begin
Rot3D1.BoundBoxSize := SBBBSize.Position;
end;

(***************************************************************)
procedure TForm1.SBAutoRotClick(Sender: TObject);
(***************************************************************)


begin
vax := 0;
vay := 0;
while SBAutoRot.Down do
  begin
  Application.ProcessMessages;
  vax := vax + 1.12;
  if vax > 360 then
    vax := vax-360;
  vay := vay + 1.33;
  if vay > 360 then
    vay := vay - 360;
  Rot3D1.SetViewAngles (vax, vay, 90);
  end;
Rot3D1.SetViewAngles (SBAngX.Position, SBAngY.Position, SBAngZ.Position);
end;


(***************************************************************)
procedure TForm1.SBAxSizeChange(Sender: TObject);
(***************************************************************)

begin
Rot3D1.AxSize := SBAxSize.Position;
end;

(***************************************************************)
procedure TForm1.Rotate1Click(Sender: TObject);
(***************************************************************)

begin
Rot3D1.MouseAction := maRotate;
end;

(***************************************************************)
procedure TForm1.Zoom1Click(Sender: TObject);
(***************************************************************)

begin
Rot3D1.MouseAction := maZoom;
end;

(***************************************************************)
procedure TForm1.Pan1Click(Sender: TObject);
(***************************************************************)

begin
Rot3D1.MouseAction := Rot3D.maPan;
end;

(***************************************************************)
procedure TForm1.ToClipboard1Click(Sender: TObject);
(***************************************************************)

begin
Rot3D1.CopyToClipboard;
end;


(***************************************************************)
procedure TForm1.ToBMPFile1Click(Sender: TObject);
(***************************************************************)

begin
SaveDialog1.Filename := '*.bmp';
if SaveDialog1.Execute then
  Rot3D1.CopyToBMP (SaveDialog1.Filename);
end;

end.
